/*\
 *  UnFocus.Rexx V1.0
 *   Performs a complex smoothing operation on an image buffer.
 *
 *   Written By: Ian Smith / 27 Gibson St / North East, PA 16428
 *               Usenet: IanSmith@moose.erie.net
 *               Usenet backup: IanSmith@psu.edu
 *               Web: http://moose.erie.net/~iansmith/
 *               Digital Matrix BBS (814) 825-3783 FIDO: 1:2601/564.0
 *
\*/
                   /*    Quiet: No text output     */
                   /*  Verbose: Full text output   */
                   /*   Normal: Normal text output */
Display="Quiet"
CmdPath="CMPI:"
CmdName="UnFocus"

If ~Show('L',"rexxsupport.library") Then
 If ~AddLib("rexxsupport.library",0,-30,0) Then
  Error('Can not find "rexxsupport.library"!')

If Exists("CMPI:"CmdName) Then        /* This should find the executable */
 CmdPath="CMPI:"CmdName               /* no matter where its hiding!     */
Else If Exists("C:"CmdName) Then
 CmdPath="C:"CmdName
Else If Exists("REXX:"CmdName) Then
 CmdPath="REXX:"CmdName
Else If Exists("RXPI:"CmdName) Then
 CmdPath="RXPI:"CmdName
Else If Exists("Rexx:picmdpath") Then
 If Open(In,"Rexx:picmdpath","R") Then Do
  CmdPath=ReadLn(In)||CmdName
  Call Close(In)
 End
If ~Exists(CmdPath) Then
 DispError("I can't find the UnFocus executable!")

Options Results
If Display="Normal" Then
 Args=""
Else
 Args=Display
Address("IM_Port")
'current'                                     /* Get system and user */
Parse Var Result BName ',' BNumber ',' .      /* information to use. */
XSize=5; YSize=5; Weight=85
CustPath=""; CustName=""; FileName="RAM:"
TempVar=GetClip('UnFocus_RAM_Storage')
If TempVar~="" Then Do
 Parse Var TempVar XSize YSize AskedWeight
 If XSize<3 | XSize>49 Then
  XSize=5
 If YSize<3 | YSize>49 Then
  YSize=5
 If AskedWeight<1 | AskedWeight>254 Then
  AskedWeight=96
 FileName=Strip(Filename,"B")
End

'gadgets "Weighted","Circle","Fast","Square","Load","Custom"'
MatrixType=Result
If MatrixType=0 Then
 Exit
If MatrixType=1 Then
 Args=Args 'C'
If MatrixType=2 Then
 Args=Args 'S'
If MatrixType=3 Then Do
 FullFile=GetClip('UnFocus_FileName')
 File=Right(':'FullFile,Length(':'FullFile)-LastPos(':',':'Translate(FullFile,':','/')))
 Path=Left(FullFile,Length(FullFile)-Length(File))
 'filerequest "'Path'", "'File'", "", "Select user matrix file..."'
 If Result="FR_CANCELLED" Then
  Exit
 FileName=Result
 Args=Args 'F='FileName
 Call SetClip('UnFocus_FileName',FileName)
End

'gadgets "Ignore","Edge","Black","Edge","White","Edge","Custom","Edge"'
EdgeType=Result
If EdgeType=0 Then
 Exit
If EdgeType=1 Then
 EdgeColors=""
If EdgeType=2 Then
 EdgeColors="E=0,0,0"
If EdgeType=3 Then
 EdgeColors="E=255,255,255"
If EdgeType=4 Then Do
 'askrgb'
 EdgeColors="E="||Space(Result,0)
End

If MatrixType=1 | MatrixType=2 Then Do
 'gadgets "No Aspect","Correction","Manual Aspect","Correction","Auto Aspect","Correction"'
 AspectType=Result
 If AspectType=0 Then
  Exit
 If AspectType=1 Then
  TSize=1
 Else
  TSize=3
 'askprop "X Size: "' XSize TSize '49'
 XSize=Result
 If AspectType=1 Then
  YSize=XSize
 If AspectType=2 Then Do
  If XSize>2 Then
   TSize=1
  Else
   TSize=3
  'askprop "(X='XSize') Y Size: "' YSize TSize '49'
  YSize=Result
 End
 If AspectType=3 Then Do
  'imageaspect' BNumber
  Parse Var Result XA", "YA
  YSize=XSize*(XA/YA)
 End
 If MatrixType=1 Then Do
  'askprop "('XSize'x'YSize') Weight: "' AskedWeight '1 254'
  AskedWeight=Result
  Weight=256-AskedWeight
 End
End
Call SetClip('UnFocus_RAM_Storage',XSize" "YSize" "AskedWeight)
Result="PPP"
'area'

If Display~="Quiet" Then
'jackin'                    /* Now to execute the binary. */
jacker = Result             /* One, two, three....  Bang! */
'backuptoundo'
'lockimage' BNumber
ElapsedTime=Time('S')
Address Command ''CmdPath Jacker XSize YSize Weight Args EdgeColors
'unlockimage' BNumber
If Display~="Quiet" Then Do
 Say " Smoothing took" Time(s)-ElapsedTime "seconds."
 Say
 'tofront'
End
'redraw'
Exit 0

DispError:                  /* Generic error handling. */
 Parse Arg Message
 Address("IM_Port")
 'message "'Message'"'
 Exit 10
Return

